/////////////////////////////////////////////////////////////////////////////////////////
// Classe Configuracio: instanciada quan es carrega l'arxiu de configuració del widget                                        /
// Dona acces a les dades del arxiu de configuració durant lexecucio
// Forma part del Model
// La llista d'atributs coincideix amb les etiquetes de l'arxiu de configuracio meteoclimatic.xml
///////////////////////////////////////////////////////////////////////////////////////////
package widgets.MeteoclimaticRSS
{
	public class Configuracio
	{
		protected var fields:XMLList;
		protected var titleField:String;
		protected var linkField:String;
		protected var refreshRate:Number;
		protected var zoomScale:Number;
		protected var useProxy:String;
		protected var loadingLabel:String;
		protected var queryFields:XMLList;
		protected var rangos:Array;
		protected var URLRangs:Array;
		
		//Constructor
		public function Configuracio(configXML:XML)
		{
			var cnfRangs:XMLList;
			cnfRangs=configXML..rang;
			
			this.rangos = new (Array);
			for (var i:int=0;i < cnfRangs.length();i++)
			{
				var rango1:Rangos=new Rangos(cnfRangs[i].name,Number(cnfRangs[i].name1),Number(cnfRangs[i].name2),Number(cnfRangs[i].name3),Number(cnfRangs[i].name4),Number(cnfRangs[i].name5),cnfRangs[i].name6,cnfRangs[i].name7);
				rangos.push(rango1);
			}
						
			this.setQueryFields(configXML.fields.field);
			this.setLoadingLabel(configXML.loadinglabel);
			this.setTitleField(configXML.titlefield);
			this.setLinkField(configXML.linkfield);
			this.setRefreshrate(configXML.refreshrate);
			this.setZoomScale(configXML.zoomscale);
			this.setUseProxy(configXML.useproxy);
			this.setURLRangs(configXML..URLrang);
			if (Number(configXML.zoomscale) > 0)
			{
				this.setZoomScale(Number(configXML.zoomscale));
			}			
		}
		///////////////////////////////////
		// metodes setvariables
		///////////////////////////////////
		public function setTitleField(pTitleField:String):void
		{
			this.titleField=pTitleField;
		}
		public function setLinkField(pLinkField:String):void
		{
			this.linkField=pLinkField;
		}
		public function setRefreshrate(pRefreshrate:Number):void
		{
			this.refreshRate=pRefreshrate;
		}
		public function setZoomScale(pZoomScale:Number):void
		{
			this.zoomScale=pZoomScale;
		}
		public function setUseProxy(pUseProxy:String):void
		{
			this.useProxy=pUseProxy;
		}
		public function setLoadingLabel(pLoadingLabel:String):void
		{
			this.loadingLabel=pLoadingLabel;
		}
		public function setQueryFields(pQueryFields:XMLList):void
		{
			this.queryFields = pQueryFields;
		}
		public function setRangos(pRangos:Array):void
		{
			this.rangos=pRangos;
		}
		public function setURLRangs(pURLRangs:XMLList):void
		{
			this.URLRangs=[];
			for (var i:int=0; i < pURLRangs.length();i++)
			{
				var temp:String=pURLRangs[i].url;
				this.URLRangs[i]=temp;
			}
		}
		
		///////////////////////////////////
		// metodes getvariables
		///////////////////////////////////
		public function getTitleField():String
		{
			return this.titleField;
		}
		public function getLinkField():String
		{
			return this.linkField;
		}
		public function getRefreshrate():Number
		{
			return this.refreshRate;
		}
		public function getZoomScale():Number
		{
			return this.zoomScale;
		}
		public function getUseProxy():String
		{
			return this.useProxy;
		}
		public function getLoadingLabel():String
		{
			return this.loadingLabel;
		}
		public function getQueryFields():XMLList
		{
			return this.queryFields;
		}
		public function getRangos():Array
		{
			return this.rangos;
		}
		public function getURLRangs():Array
		{
			return this.URLRangs;
		}
		public function getURLRang(index:int):String
		{
			return this.URLRangs[index];
		}
	}
}