//////////////////////////////////////////////////////////////////////////////////////
// Classe ControlMeteo: Correspon al Controlador dins del patro MVC
// Conte les funcions que tenen el control de l'execucio
// Les accions usuari
// I el control del canal RSS
// Rep com a parametre del constructor el Model instanciat per la Vista
// i el mante informat dels aconteixements
/////////////////////////////////////////////////////////////////////////////////////

package widgets.MeteoclimaticRSS
{
	import mx.collections.ArrayCollection;
	import mx.rpc.http.mxml.HTTPService;
	import mx.rpc.events.ResultEvent;
	import mx.controls.Alert;

	
	public class ControlMeteo
	{
		private var modelMeteo:ModelMeteo;
		private var rssService:HTTPService;
		private var useProxy:Boolean;
		private var rsstype:String = "";
		
		// Constructor
		public function ControlMeteo(pModelMeteo:ModelMeteo)
		{
			this.modelMeteo = pModelMeteo;
			rssService = new HTTPService;
			rssService.addEventListener("result", loadRSSData);  
			rssService.addEventListener("fault", faultHandler);
			rssService.resultFormat="e4x";
			rssService.method = "POST";  
		}
		
		// Llença la crida el servei RSS
		// la URL la pren del Model que l'ha actualitzat segons filtres geografics seleccionats per l'usuari
		//
		public function queryRSSData():void
		{
			if (modelMeteo.getActualQuerySource())
			{
				if (modelMeteo.getConfiguracio().getUseProxy())
				{
					rssService.useProxy=true;
					rssService.url = modelMeteo.getConfiguracio().getUseProxy() + "?" + modelMeteo.getActualQuerySource();
				}
				else
				{
					rssService.useProxy=false;
					rssService.url = modelMeteo.getActualQuerySource();
				}
				rssService.send();
				modelMeteo.setShowMessages(modelMeteo.getConfiguracio().getLoadingLabel());
			}
		}
		
		//
		// Escolta event d'entrada del canal RSS
		// Actualitza el model amb les dades rebudes
		//
		private function loadRSSData(event:ResultEvent):void
		{
			var ac:ArrayCollection;
			try
			{
				if (event.result is XML)
				{
					var x:XML = XML(event.result);
					if (x.name() == "rss" && Number(x.@version) <= 2)
					{
						rsstype = "RSS";
						ac = this.modelMeteo.parseRSS(x);							
					}
					else if (x.namespace().uri.toLowerCase() == "http://www.w3.org/2005/atom")
					{
						rsstype = "ATOM";
						ac = this.modelMeteo.parseAtom(x);
					}
					else
					{
						modelMeteo.setShowMessages("Unable to determine RSS feed type.");
					}
				
				}
				else
				{
					modelMeteo.setShowMessages("HTTP Response is not XML.");
				}
				
				modelMeteo.createEstacioRSSFeed(ac);;
				
				modelMeteo.setShowMessages("");
			}
			catch (error:Error)
			{
				modelMeteo.setShowMessages("A problem occurred while parsing the RSS feed. " + error.message);
			}
		}
		
		//
		// En cas d'error informa al model
		//
		private function faultHandler(event:mx.rpc.events.FaultEvent):void
		{
			var sInfo:String = "Error: ";
			sInfo += "Event Target: " + event.target + "\n\n";
			sInfo += "Event Type: " + event.type + "\n\n";
			sInfo += "Fault Code: " + event.fault.faultCode + "\n\n";
			sInfo += "Fault Info: " + event.fault.faultString;
			modelMeteo.setShowMessages(sInfo);
		}
		
		//
		// Gestio d'event canvi en seleccio combo Comunitats delegat per la Vista
		//
		public function cmbRegChange(index:int):void
		{
			modelMeteo.setComunitat(index);
		}
		
		//
		// Gestio d'event canvi en seleccio combo Provincies delegat per la Vista
		//
		public function cmbProvChange(index:int):void
		{
			modelMeteo.setProvincia(index);
		}
		//
		// Gestio d'event canvi en seleccio variable meteorologica cedit per la Vista
		//
		public function buttonSelectedChanged(variableSelected:String):void
		{
			modelMeteo.setSelectedVariable(variableSelected);
		}
	}
}