/////////////////////////////////////////////////////////////////////////////////////////
// Classe Rangos: Classe que defineix la informació dels difernets rangs
// Segons informacio configurada al arxiu meteoclimatic xml                          
// Variable: identifica la variable meteorologica (temp.,humitat, pressio,vent,pluja)
// rang1..rang5: valor dels diferents valors de le'escala de rangs                                                                 /
// escala: defineix si la variable te rangs ascendents o descendents per la configuracio
//			de colors a l'hora de visualitzar
// unitat: unitat de la variable (ºC, %, hPa, km/h,mm)                                     
/////////////////////////////////////////////////////////////////////////////////////////
package widgets.MeteoclimaticRSS
{
	public class Rangos
	{
		private var variable:String;
		private var rang1:Number;
		private var rang2:Number;
		private var rang3:Number;
		private var rang4:Number;
		private var rang5:Number;
		private var escala:Boolean;
		private var unitat:String;
		
		// 
		// Constructor
		//
		public function Rangos(pVariable:String,pRang1:Number,pRang2:Number,pRang3:Number,pRang4:Number,pRang5:Number,pEscala:Number,pUnitat:String)
		{
			this.setVariable(pVariable);
			this.setRang1(pRang1);
			this.setRang2(pRang2);
			this.setRang3(pRang3);
			this.setRang4(pRang4);
			this.setRang5(pRang5);
			this.setEscala(Boolean(pEscala));
			this.setUnitats(pUnitat);
			
		}
		
		////////////////////////////////////////////////////
		// Metodes setvariable
		////////////////////////////////////////////////////
		
		public function setVariable(pVariable:String):void
		{
			this.variable = pVariable;
		}
		public function setRang1(pRang1:Number):void
		{
			this.rang1 = pRang1;
		}
		public function setRang2(pRang2:Number):void
		{
			this.rang2 = pRang2;
		}
		public function setRang3(pRang3:Number):void
		{
			this.rang3 = pRang3;
		}
		public function setRang4(pRang4:Number):void
		{
			this.rang4 = pRang4;
		}
		public function setRang5(pRang5:Number):void
		{
			this.rang5 = pRang5;
		}
		public function setEscala(pEscala:Boolean):void
		{
			this.escala=pEscala;
		}
		public function setUnitats(pUnitat:String):void
		{
			this.unitat=pUnitat;
		}
		
		////////////////////////////////////////////////////////
		// Metodes getvariables
		////////////////////////////////////////////////////////
		
		public function getVariable():String
		{
			return this.variable;
		}
		public function getRang1():Number
		{
			return this.rang1;
		}
		public function getRang2():Number
		{
			return this.rang2;
		}
		public function getRang3():Number
		{
			return this.rang3;
		}
		public function getRang4():Number
		{
			return this.rang4;
		}
		public function getRang5():Number
		{
			return this.rang5;
		}
		public function getEscala():Boolean
		{
			return this.escala;
		}
		public function getUnitats():String
		{
			return this.unitat;
		}
	}
}